#include "mns.h"
#define timed_read(a,b,c) { alarm(TIMEOUT); read(a,b,c); alarm(0); }

#define BUFFER_SIZE 160
#define CGI_BUF_SIZE 240
#define CGIMAX 21
static const char *cginame[CGIMAX] = {
  "test-cgi", "nph-test-cgi", "Count.cgi", "phf", "php.cgi", "handler", "webgais",
  "websendmail", "webdist.cgi", "faxsurvey", "htmlscript", "pfdisplay",
  "perl.exe", "wwwboard.pl", "www-sql", "aglimpse", "man.sh",
  "view-source", "campas" };

struct node *qpop (struct in_addr target, struct node *walk) {
  int sockfd;
  char *buffer;
  SAin qpop;

  qpop.sin_family = AF_INET;
  qpop.sin_port = htons (110);
  qpop.sin_addr = target;

  if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    return walk;

  signal (SIGALRM, &sighandler);

  alarm (TIMEOUT);

  if (!connect (sockfd, (SA *) & qpop, sizeof (SAin)))
    {
      alarm (0);
      sleep (1);

      buffer = calloc (BUFFER_SIZE, 1);

      timed_read (sockfd, buffer, BUFFER_SIZE - 1);

      /* thanks diab */

      if (strstr (buffer, "QPOP") != NULL) {
	  if (strstr (buffer, "2.2") != NULL)
	    stralloc (walk, "\n\t\tQPOP 2.2\n");
	  else if (strstr (buffer, "2.41beta1") != NULL)
	    stralloc (walk, "\n\t\tQPOP 2.41beta1\n");
	  else if (strstr (buffer, "2.3") != NULL)
	    stralloc (walk, "\n\t\tQPOP 2.3\n");
	  else if (strstr (buffer, "2.4") != NULL)
	    stralloc (walk, "\n\t\tQPOP 2.4\n");
	  else if (strstr (buffer, "2.1.4-R3") != NULL)
	    stralloc (walk, "\n\t\tQPOP 2.1.4-R3\n");
	}
      else if (strstr (buffer, "SCO") != NULL) {
	  if (strstr (buffer, "2.1.4-R3") != NULL)
	    stralloc (walk, "\n\t\tSCO POP 2.1.4-R3\n");
	  else if (strstr (buffer, "5.0.0") != NULL)
	    stralloc (walk, "\n\t\tSCO POP 5.0.0\n");
	}

      free (buffer);
    }
  close (sockfd);

  return walk;
}

struct node *
imap (struct in_addr target, struct node *walk)
{

  int sockfd;
  char *buffer;
  SAin imap;

  imap.sin_family = AF_INET;
  imap.sin_port = htons (143);
  imap.sin_addr = target;


  if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    return walk;


  signal (SIGALRM, &sighandler);

  alarm (TIMEOUT);


  if (!connect (sockfd, (SA *) & imap, sizeof (SAin)))
    {
      alarm (0);
      sleep (1);

      buffer = calloc (BUFFER_SIZE, 1);
      timed_read (sockfd, buffer, BUFFER_SIZE - 1);

      if(strstr(buffer, "IMAP4rev1") != NULL) {
         if (strstr(buffer, "v10.223") != NULL)
            stralloc(walk, "\n\t\tIMAP4rev1 v10.223");
         else if(strstr(buffer, "Service 9.0") != NULL)
            stralloc(walk, "\n\t\tIMAP4rev1 Service 9.0");
         else if(strstr(buffer, "v10.205") != NULL)
            stralloc(walk, "\n\t\tIMAP4rev1 v10.205");
         else if(strstr(buffer, "v10.203") != NULL)
            stralloc(walk, "\n\t\tIMAP4rev1 v10.203");
         else if(strstr(buffer, "v10.171") != NULL)
            stralloc(walk, "\n\t\tIMAP4rev1 v10.171");
         else if(strstr(buffer, "v10.183") != NULL)
            stralloc(walk, "\n\t\tIMAP4rev1 v10.183");
         else if(strstr(buffer, "v10.166") != NULL)
            stralloc(walk, "\n\t\tIMAP4rev1 v10.166");
         else if(strstr(buffer, "v10.233") != NULL)
            stralloc(walk, "\n\t\tIMAP4rev1 v10.233");
         else if(strstr(buffer, "v10.190") != NULL)
            stralloc(walk, "\n\t\tIMAP4rev1 v10.190");
      }

      free (buffer);
    }

  close (sockfd);

  return walk;
}

struct node *cgi (struct in_addr target, struct node *head) {
  time_t timeout;
  int sockfd[CGIMAX], sockfd1st;
  int i, nph_test_cgi = 0;
  SAin http;
  struct node *walk = head;
  char cgimsg[70];
  char cgibuff[CGI_BUF_SIZE];
  char *nph_p = NULL,
       *nph_alloc = NULL;

  http.sin_family = AF_INET;
  http.sin_port = htons (80);
  http.sin_addr = target;

  if ((sockfd1st = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    return walk;

  signal (SIGALRM, &sighandler);

  stralloc (walk, "\n\t\tCGI ->");

  alarm (TIMEOUT);

  if(!connect(sockfd1st, (SA *)&http, sizeof(SAin))) {
     alarm (0);
     sockfd[0] = sockfd1st;
     sprintf(cgimsg, "GET /cgi-bin/%s HTTP/1.0\n\n", cginame[0]);
     write(sockfd[0], cgimsg, strlen(cgimsg));
      
     for (i = 1; i < CGIMAX; i++) {
        if((sockfd[i] = socket (AF_INET, SOCK_STREAM, 0)) < 0) break;

        alarm(TIMEOUT);
        connect(sockfd[i], (SA *)&http, sizeof(SAin));
        alarm(0);

        sprintf(cgimsg, "GET /cgi-bin/%s HTTP/1.0\n\n", cginame[i]);
        write(sockfd[i], cgimsg, strlen(cgimsg));
     }
      
     sleep(TIMEOUT << 1);
     
     for(i = 0; i < CGIMAX; i++) {
        bzero(cgibuff, CGI_BUF_SIZE);
        timed_read(sockfd[i], cgibuff, CGI_BUF_SIZE - 1);
        close(sockfd[i]);
        if(strstr(cgibuff, "200 OK") != NULL) {
           stralloc(walk, cginame[i]);
           if(i == 1) nph_test_cgi = 1; /* nph-test-cgi?* */
        }
     }
  }
  
  if(nph_test_cgi) {
     if((sockfd1st = socket(AF_INET, SOCK_STREAM, 0)) >= 0) {
        alarm(TIMEOUT);
        if(!connect(sockfd1st, (SA *)&http, sizeof(SAin))) {
           alarm(0);
           nph_alloc = calloc(1, 2048);
           sprintf(cgimsg, "GET /cgi-bin/%s?* HTTP/1.0\n\n", cginame[1]);
           write(sockfd1st, cgimsg, strlen(cgimsg));
           timeout = time(NULL) + TIMEOUT;
           while((recv(sockfd1st, nph_alloc, 2047, MSG_PEEK) >= 0) &&
                       (timeout > time(NULL)))
           {
              nph_p = nph_alloc;
              if((nph_p = strstr(nph_alloc, "QUERY_STRING = ")) != NULL) {
                 nph_p += sizeof("QUERY_STRING = ") - 1;
                 if(strchr(nph_p, '\n') != NULL) {
                    *strchr(nph_p, '\n') = '\0';
                    if(nph_p[0] != '*') break;
                 }
              }
              nph_p = NULL;
           }
        }
        alarm(0);
        close(sockfd1st);
     }
  }
  
  if(nph_p != NULL) {
     stralloc(walk, "\n\t\t/cgi-bin/* ->");
     stralloc(walk, nph_p);
  }
  if(nph_alloc != NULL) free(nph_alloc);
  
  if((head->next)->next == NULL) {
     free(head->string);
     free(head->next);
     bzero(head, sizeof (struct node));
     return head;
  } else return walk;
}

struct node *
ftp (struct in_addr target, struct node *walk)
{
  int sockfd;
  char *buffer;
  SAin saftp;
  char *ban_p;

  saftp.sin_family = AF_INET;
  saftp.sin_port = htons (21);
  saftp.sin_addr = target;

  if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    return walk;

  signal (SIGALRM, &sighandler);

  alarm (TIMEOUT);
  if (!connect (sockfd, (SA *) & saftp, sizeof (SAin)))
    {
      alarm (0);
      sleep (1);

      buffer = calloc (BUFFER_SIZE, 1);

      timed_read (sockfd, buffer, BUFFER_SIZE - 1);
      if((ban_p = strstr(buffer, "-2.4.2-academ[BETA-1")) != NULL) {
      ban_p += sizeof("-2.4.2-academ[BETA-1") - 1;
         switch(*ban_p) {
            case '5': stralloc(walk, "\n\t\tWu-FTP 2.4.2 BETA-15"); break;
            case '6': stralloc(walk, "\n\t\tWu-FTP 2.4.2 BETA-16"); break;
            case '7': stralloc(walk, "\n\t\tWu-FTP 2.4.2 BETA-17"); break;
            case '8': stralloc(walk, "\n\t\tWu-FTP 2.4.2 BETA-18"); break;
         }
      } else if ((strstr (buffer, "ProFTPD")) != NULL)
         if ((strstr (buffer, "1.2.0pre1")) != NULL)
            stralloc (walk, "\n\t\tProFTPD 1.2.0pre1");

      free (buffer);
    }
  close (sockfd);

  return walk;
}
